#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <string>
#include <list>
#include <map>
#include <vector>
#include <math.h>

using namespace std;

#include "../common/disasm.hpp"

int main(int argc,char **argv)
{
    if(argc!=2)
    {
        printf("usage: %s <objfile>\n",argv[0]);
        exit(0);
    }

    ifstream is(argv[1]); // open a file stream
    string line;             // S string for a line to read
    while(is.good())         // As long as there's data
    {
        uint16_t instr;
        is >> line;          // read a line
        istringstream sstr(line);
        sstr >> hex >> instr;
        
        printf("%s\n",disassemble(instr).c_str());
    }
    
    return 0;
}
